#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct GeoVizDefinitionV1 {
    #[builder(default, list(item(type = super::GeoPlotFromLatLong)))]
    #[serde(rename = "plots", skip_serializing_if = "Vec::is_empty", default)]
    plots: Vec<super::GeoPlotFromLatLong>,
    #[builder(default, into)]
    #[serde(
        rename = "backgroundOverlays",
        skip_serializing_if = "Option::is_none",
        default
    )]
    background_overlays: Option<Vec<super::GeoPlotFromOverlay>>,
    #[builder(default, into)]
    #[serde(rename = "title", skip_serializing_if = "Option::is_none", default)]
    title: Option<String>,
    #[builder(default, list(item(type = super::GeoCustomFeature)))]
    #[serde(rename = "customFeatures", skip_serializing_if = "Vec::is_empty", default)]
    custom_features: Vec<super::GeoCustomFeature>,
    #[builder(default, into)]
    #[serde(
        rename = "customMeasurements",
        skip_serializing_if = "Option::is_none",
        default
    )]
    custom_measurements: Option<Vec<super::GeoCustomMeasurement>>,
    #[builder(default, into)]
    #[serde(rename = "baseTileset", skip_serializing_if = "Option::is_none", default)]
    base_tileset: Option<super::GeoBaseTileset>,
    #[builder(default, into)]
    #[serde(
        rename = "additionalTileset",
        skip_serializing_if = "Option::is_none",
        default
    )]
    additional_tileset: Option<super::GeoAdditionalTileset>,
    #[builder(default, into)]
    #[serde(rename = "unitSystem", skip_serializing_if = "Option::is_none", default)]
    unit_system: Option<super::GeoUnitSystem>,
}
impl GeoVizDefinitionV1 {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn plots(&self) -> &[super::GeoPlotFromLatLong] {
        &*self.plots
    }
    #[inline]
    pub fn background_overlays(&self) -> Option<&[super::GeoPlotFromOverlay]> {
        self.background_overlays.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn title(&self) -> Option<&str> {
        self.title.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn custom_features(&self) -> &[super::GeoCustomFeature] {
        &*self.custom_features
    }
    #[inline]
    pub fn custom_measurements(&self) -> Option<&[super::GeoCustomMeasurement]> {
        self.custom_measurements.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn base_tileset(&self) -> Option<&super::GeoBaseTileset> {
        self.base_tileset.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn additional_tileset(&self) -> Option<&super::GeoAdditionalTileset> {
        self.additional_tileset.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn unit_system(&self) -> Option<&super::GeoUnitSystem> {
        self.unit_system.as_ref().map(|o| &*o)
    }
}
